sub GetFtpFile
{
	my ($address, $savedir) = @_;
	if ($ftperror) { print $skin->Template('page_error', "$lang{'can_not_get_via_ftp'} $ftperror"); return; }
	$address =~ s!ftp://!ftp://anonymous:$EMAIL@! if $P{'address'} !~ '@';
	$address =~ 'ftp://([^:@/]*):*([^:@/]*@*[^:@/]*)@([^:@/]+):*(\d*)(.+)';
	my ($ftplogin, $ftppassword, $ftphost, $ftpport, $ftpfile) = ($1,$2,$3,$4,$5);
	$ftpport = 21 if !$ftpport;
	my $FTP = Net::FTP->new($ftphost, Debug => 0, Port => $ftpport, Passive => $FTPPASSIVE);
	if ($@) { print $skin->Template('page_error', "$lang{'can_not_connect_to_ftp'} $@"); return; }
	$FTP->login($ftplogin, $ftppassword);
	if (!$FTP->pwd()) { print $skin->Template('page_error', $lang{'can_not_login_to_ftp'}); return; }
	$FTP->binary();
	$ftpfile =~ /^.*(\\|\/)(.*)/; my $targetfile = "$savedir$DIRSEPARATOR$2";
	if (!$FTP->get($ftpfile, $targetfile)) { print $skin->Template('page_error', "$lang{'can_not_get_file'} $ftpfile"); }
	else { chmod (oct($CHMODFILES), $targetfile) || print $skin->Template('page_error', "$lang{'can_not_chmod'} $targetfile"); }
	$FTP->quit;
}

sub GetHttpFile
{
	my ($address, $savedir) = @_;
	if ($httperror) { print $skin->Template('page_error', "$lang{'can_not_get_via_http'} $httperror"); return; }
	local *FILE;
	my $HTTP = new HTTP::Lite;
	$address =~ /^.*(\\|\/)(.*)/; my $targetfile = "$savedir$DIRSEPARATOR$2";
	open FILE, ">$targetfile";
	binmode('FILE');
	my $status = $HTTP->request($address, \&savefile, FILE) or print $skin->Template('page_error', "$lang{'can_not_get_file'} $!");
	close FILE;
	if ($status ne '200') { print $skin->Template('page_error', "$lang{'http_request_failed'} $status:".$HTTP->status_message()); unlink "$targetfile" if $status ne '200'; }
	else { chmod (oct($CHMODFILES), $targetfile) || print $skin->Template('page_error', "$lang{'can_not_chmod'} $targetfile");  }
	sub savefile { my ($phase,$dataref,$cbargs) = @_; print $cbargs $$dataref; return undef; }
}

sub FtpFiles
{
	my ($ftphost, $ftpport, $ftplogin, $ftppassword, $ftpdir, @files) = @_;
	if ($ftperror) { print $skin->Template('page_error', "$lang{'can_not_upload_via_ftp'} $ftperror"); return; }
	if ($ftphost)
	{
		$FTP = Net::FTP->new($ftphost, Debug => 0, Port => $ftpport, Passive => $FTPPASSIVE);
		if ($@) { print $skin->Template('page_error', "$lang{'can_not_connect_to_ftp'} $@"); return; }
		$FTP->login($ftplogin, $ftppassword);
		if (!$FTP->pwd()) {  print $skin->Template('page_error', $lang{'can_not_login_to_ftp'}); return; }
		$FTP->binary();
	}
	$FTP->cwd($ftpdir);
	if ($FTP->pwd() !~ /$ftpdir/) { print $skin->Template('page_error', "$lang{'can_not_change_ftp_dir'} $ftpdir"); return; };
	foreach $file(@files)
	{
		print ' ';
		if (-d "$file")
		{
			my ($file2, @files) = ();
			local *DIR;
			opendir (DIR, $file);
			while ($file2 = readdir(DIR)) { push(@files, "$file$DIRSEPARATOR$file2") if ($file2 ne '.' and $file2 ne '..'); }
			closedir(DIR);
			$file =~ /^.*(\\|\/)(.*)/;
			my $dir = $2;
			$FTP->mkdir("$dir");
			&FtpFiles('', '', '', '', "$ftpdir/$dir", @files) if ($file ne '.' and $file ne '..');
			$FTP->cwd($ftpdir);
			if ($FTP->pwd() !~ /$ftpdir/) { print $skin->Template('page_error', "$lang{'can_not_change_ftp_dir'} $ftpdir"); return; };
		}
		else { print $skin->Template('page_error', "$lang{'can_not_upload_file'} $file $lang{'to_ftp_dir'} $ftpdir") if !($FTP->put($file)) }
	}
	$FTP->quit if $ftphost;
}

sub EmailFiles
{
	my ($fromemail, $toemail, $subject, $body, @files) = @_;
	my ($sm) = ();
	if ($sendmailerror) { print $skin->Template('page_error', "$lang{'can_not_email'} $sendmailerror") }
	else
	{
		$sm = new SendMail($SMTP, $SMTPPort);
		$sm->setDebug($sm->OFF);
		$sm->From($fromemail);
		$sm->To($toemail);
		$sm->Subject($subject);
		$sm->setMailHeader('X-Mailer', 'indexsoft site-up (http://www.indexsoft.com)');
		$body =~ s/\n/\r\n/g;
		$sm->setMailBody($body);
		grep(do{$sm->Attach($_) if (-e $_)}, @files);
		if ($sm->sendMail() != 0) { print $skin->Template('page_error', "$lang{'can_not_email'} ".$sm->{'error'}) };
	}
}

sub PackFiles
{
	my ($dir, $archivename, @files) = @_;
	my ($cmd, $fileslist, $sep) = ();
	if ($OS eq 'win') { $cmd = $ADDARCHIVEWIN } else { $cmd = $ADDARCHIVENIX };
	$sep = qq{ $dir$DIRSEPARATOR};
	$sep = qq{" "$dir$DIRSEPARATOR} if $cmd =~ /\"%files_list%\"/;
	$fileslist = join($sep, @files);
	$cmd =~ s'%archive_name%'$archivename'ge;
	$cmd =~ s'%files_list%'$dir.$DIRSEPARATOR.$fileslist'ge;
	print '<p><pre>'; my $error = system "$cmd $TAKEERRORS"; print '</pre></p>';
	print $skin->Template('page_error', "$lang{'can_not_pack'} $archivename<br>$lang{'command'} $cmd") if $error;
	chmod (oct($CHMODFILES), "$archivename") || print $skin->Template('page_error', "$lang{'can_not_chmod'} $archivename");
}

sub UnPackFiles
{
	my ($archivename, $dir) = @_;
	my ($cmd) = ();
	($OS eq 'win')
	?(grep(do{$cmd = $UNPACKWIN{$_} if $archivename =~ /$_$/i}, keys(%UNPACKWIN)))
	:(grep(do{$cmd = $UNPACKNIX{$_} if $archivename =~ /$_$/i}, keys(%UNPACKNIX)));
	$cmd =~ s'%archive_name%'$archivename'ge;
	$cmd =~ s'%dir_name%'$dir'ge;
	print '<p><pre>'; my $error = system "$cmd $TAKEERRORS"; print '</pre></p>';
	print $skin->Template('page_error', "$lang{'can_not_unpack'} $archivename $lang{'in_directory'} $dir<br>$lang{'command'} $cmd") if $error;
}

sub RemoveDir
{
	my ($dir) = @_;
	my ($file) = ();
	local *DIR;
	opendir (DIR, $dir);
	while ($file = readdir(DIR))
	{
		print ' ';
		if (-d "$dir$DIRSEPARATOR$file") { &RemoveDir("$dir$DIRSEPARATOR$file") if ($file ne '.' and $file ne '..') }
		else { unlink ("$dir$DIRSEPARATOR$file") || print $skin->Template('page_error', "$lang{'can_not_detele_file'} $dir$DIRSEPARATOR$file") }
	}
	closedir(DIR);
	rmdir ($dir) || print $skin->Template('page_error', "$lang{'can_not_detele_dir'} $dir")
}

sub CopyFile
{
	my ($file1, $file2) = @_;
	my ($cmd) = ();
	if ($OS eq 'win') { $cmd = qq{copy/Y "$file1" "$file2" >nul} }
	else { $cmd = qq{cp "$file1" "$file2"} };
	print '<p><pre>'; my $error = system "$cmd $TAKEERRORS"; print '</pre></p>';
	print $skin->Template('page_error', "$lang{'can_not_copy_file'} $file1 $lang{'to'} $file2") if $error;
	chmod (oct($CHMODFILES), "$file2") || print $skin->Template('page_error', "$lang{'can_not_chmod'} $file2");
}

sub CopyDir
{
	my ($file1, $file2) = @_;
	my ($file) = ();
	local *DIR;
	mkdir ("$file2", oct($CHMODDIRS)) || print $skin->Template('page_error', "$lang{'can_not_create_dir'} $file2");
	opendir (DIR, $file1);
	while ($file = readdir(DIR))
	{
		print ' ';
		if (-d "$file1$DIRSEPARATOR$file") { &CopyDir("$file1$DIRSEPARATOR$file", "$file2$DIRSEPARATOR$file") if ($file ne '.' and $file ne '..') }
		else { &CopyFile("$file1$DIRSEPARATOR$file", "$file2$DIRSEPARATOR$file") }
	}
	closedir(DIR);
}

sub UploadFile
{
	my ($curdir, $filename, $paramname) = @_;
	local *FILE;
	my ($buffer) = ();
	my $filehandle = $MULTIPARTQUERY->param($paramname);
	$filename =~ s!^.*(\\|\/)!!; 
	open(FILE, ">$curdir$DIRSEPARATOR$filename") || print $skin->Template('page_error', "$lang{'can_not_upload_file'} $filename $lang{'in_directory'} $curdir");
	binmode FILE;
	print FILE $buffer while (read($filehandle, $buffer, 1024));
	close FILE;
	chmod (oct($CHMODFILES), "$curdir$DIRSEPARATOR$filename") || $skin->Template('page_error', "$lang{'can_not_chmod'} $curdir$DIRSEPARATOR$filename");
}

sub FileInfo
{
	my ($file) = @_;
	my ($fileurl, $evalit) = ();
	my ($dev,$ino,$mode,$nlink,$uid,$gid,$rdev,$size,$atime,$mtime,$ctime,$blksize,$blocks) = stat($file);
	$evalit = "\$fileurl =~ s'".$DOCUMENT_ROOT."'".$HTTP_HOST."'g";
	$fileurl = $file;
	$fileurl =~ s/(\/|\\)/\//g;
	$evalit =~ s/(\/|\\)/\//g;
	eval ($evalit);
	$mode = sprintf "%lo", ($mode & 0777);
	my $slink = readlink $file;
	return ($mtime, $size, $fileurl, $mode, $slink);
}

sub SortFiles
{
	my (@files) = @_;
	@files = sort SortOrder @files;
	return @files;
}

sub SortOrder
{
	# 1-by name; 2-by ext; 3-by date; 4-by mode; 5-by size
	my ($sortorder) = $SORTORDER;
	if ($sortorder eq '-1') { return (lc $b cmp lc $a) }
	elsif (abs($sortorder) == 2)
	{
		my ($ext_a,$ext_b) = ();
		$a =~ /\.([^\.\0]*)\0/; $ext_a = lc $1;
		$b =~ /\.([^\.\0]*)\0/; $ext_b = lc $1;
		return ($ext_a cmp $ext_b) if $sortorder eq '2';
		return ($ext_b cmp $ext_a) if $sortorder eq '-2';
	}
	elsif (abs($sortorder) == 3)
	{
		my ($date_a, $date_b) = ();
		($_, $date_a) = split(/\0/, $a);
		($_, $date_b) = split(/\0/, $b);
		return ($date_a <=> $date_b) if $sortorder eq '3';
		return ($date_b <=> $date_a) if $sortorder eq '-3';
	}
	elsif (abs($sortorder) == 4)
	{
		my ($mode_a, $mode_b) = ();
		($_, $_, $_, $_, $mode_a) = split(/\0/, $a);
		($_, $_, $_, $_, $mode_b) = split(/\0/, $b);
		return ($mode_a <=> $mode_b) if $sortorder eq '4';
		return ($mode_b <=> $mode_a) if $sortorder eq '-4';
	}
	elsif (abs($sortorder) == 5)
	{
		my ($size_a, $size_b) = ();
		($_, $_, $size_a) = split(/\0/, $a);
		($_, $_, $size_b) = split(/\0/, $b);
		return ($size_a <=> $size_b) if $sortorder eq '5';
		return ($size_b <=> $size_a) if $sortorder eq '-5';
	}
	# default
	return (lc $a cmp lc $b);
}

sub TextDateTime
{
	my ($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime($_[0]);
	my(@mons) = ($lang{'jan'}, $lang{'feb'}, $lang{'mar'}, $lang{'apr'}, $lang{'may'}, $lang{'jun'}, $lang{'jul'}, $lang{'aug'}, $lang{'sep'}, $lang{'oct'}, $lang{'nov'}, $lang{'dec'});
	if (length($hour)==1) {$hour="0$hour"};
	if (length($min)==1) {$min="0$min"};
	if (length($sec)==1) {$sec="0$sec"};
	if (length($mday)==1) {$mday="0$mday"};
	$year = 1900+$year;
	return "$mday $mons[$mon] $year $hour\:$min\:$sec";
}

sub EscapeChars
{
  my ($var) = @_;
	$var =~ s/(\W)/'%'.uc(unpack("H2",$1))/eg;
  return $var;
}

sub ReadParameters
{
	$MULTIPARTQUERY = new CGI;
	if ($ENV{'QUERY_STRING'}) { foreach my $line($MULTIPARTQUERY->url_param) { %P -> {"$line"} = join("\0", $MULTIPARTQUERY->url_param("$line")); $P{"$line"} =~ s/\r//g; } }
	foreach my $line($MULTIPARTQUERY->param) { %P -> {"$line"} = join("\0", $MULTIPARTQUERY->param("$line")); $P{"$line"} =~ s/\r//g; }
}

sub ReadCookies
{
  my($name, $value, @cookies, $line);
  @cookies = split(/; /, $ENV{'HTTP_COOKIE'});
  foreach $line (@cookies)
  {
    ($name, $value) = split (/=/, $line);
    %COOKIES -> {"$name"} = "$value";
  }
}

sub ReloadMenu
{
	my ($url) = @_;
	my ($reload) = ();
	$url?($reload = "top.frames['menu'].location = 'menu.cgi?dir=$url'"):($reload = "top.frames['menu'].location.reload()");
	return qq{<SCRIPT LANGUAGE="JavaScript" TYPE="text/javascript">\n<!--\n$reload\n//-->\n</SCRIPT>};
}

sub JSCookie
{
  my ($name, $val, $expires) = @_;
  if ($expires) 
  {
    my ($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = gmtime($expires);
    my(@wday) = (Sunday, Monday, Tuesday, Wednesday, Thursday, Friday, Saturday);
    my(@mons) = (Jan, Feb, Mar, Apr, May, Jun, Jul, Aug, Sep, Oct, Nov, Dec);
    $year = 1900+$year;
    if (length($sec)==1) {$sec="0$sec"};
    if (length($min)==1) {$min="0$min"};
    if (length($hour)==1) {$hour="0$hour"};
    $expires = "expires=$wday[$wday], $mday-$mons[$mon]-$year $hour:$min:$sec GMT;";
  }
  else
  {
    $expires = "";
  }
	return qq{<script>\n<!--\ndocument.cookie = "$name=$val; path=/; $expires"\n//-->\n</script>\n};
}

sub ReadFDescriptions
{
	my ($dir) = @_;
	local *FILE;
	open FILE, "$dir$DIRSEPARATOR".'descript.ion';
	foreach my $line(<FILE>)
	{
		$line =~ /^\"([^\"]*)"\s+(.*)$/;
		$FDESCRIPTION{$1} = $2;
		$FDESCRIPTION{$1} =~ s/\\n/\n/g;
	}
	close FILE;
}

1;

